export interface LlmInferenceEvent {
    logging: (handle: number, message: string) => void;
    onPartialResponse: (ev: {
        handle: number;
        requestId: number;
        response: string;
    }) => void;
    onErrorResponse: (ev: {
        handle: number;
        requestId: number;
        error: string;
    }) => void;
}
type LlmModelLocation = {
    storageType: 'asset';
    modelName: string;
} | {
    storageType: 'file';
    modelPath: string;
};
export type LlmInferenceConfig = LlmModelLocation & {
    maxTokens?: number;
    topK?: number;
    temperature?: number;
    randomSeed?: number;
};
export declare function useLlmInference(config: LlmInferenceConfig): {
    generateResponse: (prompt: string, onPartial?: (partial: string, requestId: number | undefined) => void, onError?: (message: string, requestId: number | undefined) => void, abortSignal?: AbortSignal) => Promise<string>;
    isLoaded: boolean;
};
export {};
//# sourceMappingURL=llmInference.d.ts.map